<%@page import="com.sas.fsd.shared.util.StringUtil"%>
<%@page import="com.sas.solutions.cpb.web.util.ThemedImage"%>
<%@page import="com.sas.solutions.cpb.screendefs.util.DataGridHelper"%>
<%@page import="org.apache.commons.lang.StringUtils"%>
<%@page import="com.sas.solutions.cpb.screendefs.DataGridColumn"%>
<%@page import="java.util.List"%>
<%@page import="com.sas.solutions.cpb.screendefs.DataGrid"%>
<%@page import="com.sas.solutions.cpb.runtime.UIContext"%>

<%
   UIContext uiContext = (UIContext)request.getAttribute("uiContext");
   DataGrid grid = (DataGrid)request.getAttribute("datagrid");
   List<DataGridColumn> columns = (List<DataGridColumn>)request.getAttribute("datagridColumns");
   String gridVarName = (String)request.getAttribute("gridVarName");
   String actionMenuImageURL = ThemedImage.SHOW_ACTIONS.getURL(request);
   boolean printMode = ((Boolean)request.getAttribute("printMode")).booleanValue();
%>

<script type="text/javascript">

   var <%=gridVarName%>ColumnDefs = [];
   
   var column = {};
   column.field = '<%=grid.getSelectedKeyField(uiContext)%>';
   column.hidden = true;
   <%=gridVarName%>ColumnDefs.push(column);

   <%-- add the row actions column if any exist --%>
   <% if (!printMode) { %>
   CPBDataGrid.addRowActionsColumn('<%=gridVarName%>', <%=gridVarName%>ColumnDefs,
         rowActions<%=gridVarName%>, '<%=gridVarName%>_actionDropdownButton', '<%=actionMenuImageURL%>');
   <% } %>
   
   <%-- add each column defined in the grid's xml --%>
   <% String columnWidthPercent = (100 / columns.size() + "%"); %>
   //cpb.consoleLog("<%=gridVarName%> column width percent: <%=columnWidthPercent%>");
<% for (DataGridColumn column : columns) {
      String rendererFunctionName = column.getJavaScriptRendererFunctionName(uiContext);
      boolean customRenderer = StringUtils.isNotEmpty(rendererFunctionName);
      String fieldName = column.getName();
%>
   column = { name: '<%=StringUtil.escapeJSForHTML(column.getLabel(uiContext))%>', field: '<%=fieldName%>', width: '<%=columnWidthPercent%>' };
   <%if (customRenderer) {%>   column.formatter = <%=rendererFunctionName%>; <%}%>
   <%=gridVarName%>ColumnDefs.push(column);
<%}%>

<% if (/*hasTableLevelActions && */!uiContext.isScreenReadOnly() && !grid.isReadOnly(uiContext)) { %>
   if (gridActions<%=gridVarName%>.length > 0) {
      // This grid allows checkbox selection of rows
      var temp = [];
      temp.push({ type: "dojox.grid._CheckBoxSelector" });
      temp.push({ cells: <%=gridVarName%>ColumnDefs });
      <%=gridVarName%>ColumnDefs = temp;
   }
<% } %>


</script>