<%-- Copyright (c) 2003-2008 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --%>
<%@include file="/shell/default.jspf"%>
<%@page errorPage="pageError.jsp" %>
<%@taglib prefix='sas-u'  uri='http://www.sas.com/taglib/sas-util' %>
<%@taglib prefix="sas-cm" uri="http://www.sas.com/casemgmt/tag" %>
<%@page import="com.sas.solutions.casemgmt.service.ServiceLocator"%>
<sas-ui:DocType/>

<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en-US' dir='<%=WebUtil.getDirAttributeValue(request)%>' style='overflow: hidden;'>
<head>
   <meta http-equiv="X-UA-Compatible" content="IE=edge" />
   <title><sas-ui:ApplicationName/></title>
   <% com.sas.servlet.util.JavaScriptIncludeHandler.clear(request); %>
   <%@ include file="global.jspf" %>
   <script type="text/javascript">
	   // needed to turn on the context menu on right mouse click.
	   var enableContextMenu = true;
   </script>
   
   <cpb:InitializeComponentsCPB />
   
   <%@include file="/ext/cpbcore/dojo_config.jspf"%>

   <script type="text/javascript" src="scripts/siteOverrides.js"></script>
   <script type="text/javascript" src="scripts/sasFramework.js"></script>
   
   <sas-cm:include js="/shared/app.js" />
   <sas-cm:include js="/ext/cpbcore/cpb.js" />
   <sas-cm:include js="/shared/ecmApi.js" />
   <sas-cm:include js="/ext/cpbcore/pagelayout/PopupLayout.js" />
   <sas-cm:include js="/ext/cpbcore/bgoverlay/BackgroundOverlay.js" />
   <sas-cm:include js="/ext/cpbcore/browser/Event.js" />
   <sas-cm:include js="/ext/cpbcore/browser/BrowserUtil.js" />
   <sas-cm:include js="/ext/cpbcore/browser/URL.js" />
   <sas-cm:include js="/ext/cpbcore/browser/QueryString.js" />
   <sas-cm:include js="/ext/cpbcore/dialog/DialogUtil.js" />
   <sas-cm:include js="/ext/cpbcore/dialog/Dialog.js" />
   <sas-cm:include js="/ext/cpbcore/dialog/IFrameDialog.js" />
   <sas:StyleSheet styleNames="SAS Style,CPB,CPBDialog,CPBSpellChecker"/>
   <sas-cm:include css="/style/app.css" />
   <sas-cm:include flush="true" />
   
   <script type="text/javascript">
   cpb.showLog = <%=ServiceLocator.isDevelopmentMode()%>;

   // initialize the window name based on the window layout
   App.initWindowName('<%=WindowLayout.MODAL_DIALOG.toString()%>');
   
   // Override the global toggleDiv() function provided by CDD
   function toggleDiv(name, isOn)  { 
       element = getElement(name); 
       if (isOn) 
           element.style.display = "none"; 
       else 
           element.style.display = "block"; 
       if (window.PageLayout) {
          window.PageLayout.handleWindowOnResize(true); 
       } 
   }
   </script>
   
</head>
<body dir="<%=WebUtil.getDirAttributeValue(request)%>" class="claro" style="margin: 0; padding: 0;" onload="if (window.opener && window.opener.sas_framework_updateTimeout) window.opener.sas_framework_updateTimeout();">

<script type="text/javascript">
var ModalDialog = {};

ModalDialog.close = function()
{
   if (window.parent.Dialog && window.parent.Dialog.activeDialog)
   {
      window.parent.Dialog.activeDialog.hide();
   }
   else if (window.parent.closeModalWindow)
   {
      parent.closeModalWindow('modalWindow');
   }
}
</script>

<!-- Main Content -->
<tiles:insert page="<%=(String)request.getAttribute(WebKey.CONTENT_FILE)%>"/>

<sas-ui:Disable />

<script type="text/javascript">
if (window.PageLayout)
{
   PageLayout.RTL = false;
   PageLayout.LTR = true;
   PageLayout.BUTTON_BAR_ID = "buttonBarDiv";
   PageLayout.initialize();
   if (window.PopupLayout && PopupLayout.popupButtonBarContainer)
   {
      PopupLayout.popupButtonBarContainer.style.position = "absolute";
      PopupLayout.popupButtonBarContainer.style.bottom = "0px";
   }
}

if (window.DialogUtil)
{
   Event.observe(window, "load", DialogUtil.handleWindowOnLoad);
}
</script>
</body>
</html>
